/*
    The code in this file uses open source libraries provided by thecoderscorner

    DO NOT EDIT THIS FILE, IT WILL BE GENERATED EVERY TIME YOU USE THE UI DESIGNER
    INSTEAD EITHER PUT CODE IN YOUR SKETCH OR CREATE ANOTHER SOURCE FILE.

    All the variables you may need access to are marked extern in this file for easy
    use elsewhere.
 */

#ifndef MENU_GENERATED_CODE_H
#define MENU_GENERATED_CODE_H

#include <Arduino.h>
#include <tcMenu.h>
#include "tcMenuAdaFruitGfxMono.h"
#include "EthernetTransport.h"
#include <RemoteConnector.h>
#include <RemoteMenuItem.h>
#include <RuntimeMenuItem.h>
#include <ScrollChoiceMenuItem.h>
#include <IoAbstraction.h>
#include <EepromItemStorage.h>
#include <EepromAbstraction.h>
#include <RemoteAuthentication.h>

// variables we declare that you may need to access
extern const PROGMEM ConnectorLocalInfo applicationInfo;
extern TcMenuRemoteServer remoteServer;
extern Adafruit_PCD8544 gfx;
extern AdafruitDrawable gfxDrawable;
extern GraphicsDeviceRenderer renderer;
extern EthernetServer server;
extern EthernetInitialisation ethernetInitialisation;

// Any externals needed by IO expanders, EEPROMs etc


// Global Menu Item exports
extern EepromAuthenticationInfoMenuItem menuAuthenticator;
extern RemoteMenuItem menuIoTMonitor;
extern IpAddressMenuItem menuIP;
extern BackMenuItem menuBackConnectivity;
extern SubMenuItem menuConnectivity;
extern TextMenuItem menuTxt;
extern FloatMenuItem menuCurrent;
extern FloatMenuItem menuVoltsIn;
extern BackMenuItem menuBackStatus;
extern SubMenuItem menuStatus;
extern Rgb32MenuItem menuRGB;
extern ActionMenuItem menuShutdownNow;
extern AnalogMenuItem menuDelay;
extern BooleanMenuItem menuPwrDelay;
extern BackMenuItem menuBackSettings;
extern SubMenuItem menuSettings;
extern EnumMenuItem menuOnAlm;
extern AnalogMenuItem menuKitchen;
extern AnalogMenuItem menuLiving;
extern AnalogMenuItem menuHall;

// Provide a wrapper to get hold of the root menu item and export setupMenu
inline MenuItem& rootMenuItem() { return menuHall; }
void setupMenu();

// Callback functions must always include CALLBACK_FUNCTION after the return type
#define CALLBACK_FUNCTION

void CALLBACK_FUNCTION onHallLight(int id);
void CALLBACK_FUNCTION onKitchenLight(int id);
void CALLBACK_FUNCTION onLivingRoomLight(int id);
void CALLBACK_FUNCTION onPowerDownDetected(int id);

#endif // MENU_GENERATED_CODE_H
